## librime 1.10.0+dfsg1

=== CMakeLists.txt ===
set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)

cmake_minimum_required(VERSION 3.12)
project(rime)
set(CMAKE_CXX_STANDARD 17)

set(rime_version 1.10.0)
set(rime_soversion 1)

add_definitions(-DRIME_VERSION="${rime_version}")

include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build Rime as shared library" ON)
option(BUILD_MERGED_PLUGINS "Merge plugins into one Rime library" ON)
option(BUILD_STATIC "Build with dependencies as static libraries" OFF)
option(BUILD_DATA "Build data for Rime" OFF)
option(BUILD_SAMPLE "Build sample Rime plugin" OFF)
option(BUILD_TEST "Build and run tests" ON)
option(BUILD_SEPARATE_LIBS "Build separate rime-* libraries" OFF)
option(ENABLE_LOGGING "Enable logging with google-glog library" ON)
option(ALSO_LOG_TO_STDERR "Log to stderr as well as log file" OFF)
option(ENABLE_ASAN "Enable Address Sanitizer (Unix Only)" OFF)
option(INSTALL_PRIVATE_HEADERS "Install private headers (usually needed for externally built Rime plugins)" OFF)
option(ENABLE_EXTERNAL_PLUGINS "Enable loading of externally built Rime plugins (from directory set by RIME_PLUGINS_DIR variable)" OFF)
option(ENABLE_THREADING "Enable threading for deployer" ON)
option(ENABLE_TIMESTAMP "Embed timestamp to schema artifacts" ON)

set(RIME_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/rime-data" CACHE STRING "Target directory for Rime data")
set(RIME_PLUGINS_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/rime-plugins" CACHE STRING "Target directory for externally built Rime plugins")

if(WIN32)
  set(ext ".exe")
endif(WIN32)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${PROJECT_SOURCE_DIR}")

if (ENABLE_ASAN)
  set(asan_cflags "-fsanitize=address -fno-omit-frame-pointer")
  set(asan_lflags "-fsanitize=address -lasan")
  set(CMAKE_C_FLAGS "${asan_cflags} ${CMAKE_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${asan_cflags} ${CMAKE_CXX_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${asan_lflags} ${CMAKE_EXE_LINKER_FLAGS}")
  set(CMAKE_SHARED_LINKER_FLAGS "${asan_lflags} ${CMAKE_SHARED_LINKER_FLAGS}")
endif()

set(Boost_USE_STATIC_LIBS ${BUILD_STATIC})
set(Gflags_STATIC ${BUILD_STATIC})
set(Glog_STATIC ${BUILD_STATIC})
set(LevelDb_STATIC ${BUILD_STATIC})
set(Marisa_STATIC ${BUILD_STATIC})
set(Opencc_STATIC ${BUILD_STATIC})
set(YamlCpp_STATIC ${BUILD_STATIC})

set(Boost_USE_MULTITHREADED ON)
if(MSVC)
  set(Boost_USE_STATIC_RUNTIME ON)
endif()

if(LINUX)
  find_package(Boost 1.74.0 REQUIRED COMPONENTS regex)
else()
  find_package(Boost 1.77.0)
endif()
if(Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
  link_directories(${Boost_LIBRARY_DIRS})
  add_definitions(-DBOOST_DLL_USE_STD_FS)
endif()

if(ENABLE_LOGGING)

  find_package(Gflags)
  if(Gflags_FOUND)
    include_directories(${Gflags_INCLUDE_PATH})
  endif()

  find_package(Glog REQUIRED)
  if(Glog_FOUND)
    include_directories(${Glog_INCLUDE_PATH})
  endif()
  if(Glog_STATIC)
    add_definitions(-DGOOGLE_GLOG_DLL_DECL=)
  endif()

  set(RIME_ENABLE_LOGGING 1)

  if (ALSO_LOG_TO_STDERR)
     set(RIME_ALSO_LOG_TO_STDERR 1)
  endif()
endif()

find_package(Threads)

if(NOT ENABLE_THREADING)
  add_definitions(-DRIME_NO_THREADING)
endif()

if(NOT ENABLE_TIMESTAMP)
  add_definitions(-DRIME_NO_TIMESTAMP)
endif()

if(BUILD_TEST)
  find_package(GTest REQUIRED)
  if(GTEST_FOUND)
    enable_testing()
    include_directories(${GTEST_INCLUDE_DIRS})
  endif()
endif()

find_package(YamlCpp REQUIRED)
if(YamlCpp_FOUND)
  include_directories(${YamlCpp_INCLUDE_PATH})
endif()
if(YamlCpp_STATIC)
  add_definitions(-DYAML_CPP_STATIC_DEFINE)
endif()

find_package(LevelDb REQUIRED)
if(LevelDb_FOUND)
    include_directories(${LevelDb_INCLUDE_PATH})
endif()

find_package(Marisa REQUIRED)
if(Marisa_FOUND)
  include_directories(${Marisa_INCLUDE_PATH})
endif()

find_package(Opencc REQUIRED)
if(Opencc_FOUND)
include_directories(${Opencc_INCLUDE_PATH})
endif()
if(Opencc_STATIC)
  add_definitions(-DOpencc_BUILT_AS_STATIC)
endif()

find_path(X11Keysym X11/keysym.h)
if(X11Keysym)
  message(STATUS "Found X11/keysym.h at ${X11Keysym}")
  include_directories(${X11Keysym})
else()
  message(WARNING "X11/keysym.h not found.")
endif()

configure_file(
  "${PROJECT_SOURCE_DIR}/src/rime/build_config.h.in"
  "${PROJECT_BINARY_DIR}/src/rime/build_config.h")

include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/include)
link_directories(${PROJECT_SOURCE_DIR}/lib)

if(MSVC)
  # https://stackoverflow.com/a/31264946
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
  add_definitions("/wd4244 /wd4996")
endif()

if(UNIX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
endif()

if (NOT CMAKE_BUILD_PARALLEL_LEVEL)
  include(ProcessorCount)
  ProcessorCount(N)
  if (NOT N EQUAL 0)
    set(CMAKE_BUILD_PARALLEL_LEVEL ${N})
  endif()
endif()

# keep these variables lest some Rime plugin's cmake file is still using them {
if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
endif()

if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
endif()
# }

# remove target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(remove
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly|GNU|Darwin" OR MINGW)
  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  set(bindir "${CMAKE_INSTALL_FULL_BINDIR}")
  set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
  set(pkgdatadir "${RIME_DATA_DIR}")
  set(pluginsdir "${RIME_PLUGINS_DIR}")
  set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
  configure_file(
      ${PROJECT_SOURCE_DIR}/rime.pc.in
      ${PROJECT_BINARY_DIR}/rime.pc
      @ONLY)
  install(FILES ${PROJECT_BINARY_DIR}/rime.pc
    DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig)
endif()

install(FILES cmake/RimeConfig.cmake
  DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/cmake/rime)

file(GLOB rime_public_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
install(FILES ${rime_public_header_files}
  DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR})
if(INSTALL_PRIVATE_HEADERS)
  file(GLOB rime_private_header_files
    ${PROJECT_SOURCE_DIR}/src/rime/*.h
    ${PROJECT_BINARY_DIR}/src/rime/*.h)
  install(FILES ${rime_private_header_files}
    DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/rime)
  foreach(rime_private_header_files_dir algo config dict gear lever)
    file(GLOB rime_private_header_files
      ${PROJECT_SOURCE_DIR}/src/rime/${rime_private_header_files_dir}/*.h)
    install(FILES ${rime_private_header_files}
      DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/rime/${rime_private_header_files_dir})
  endforeach()
endif()

if(BUILD_DATA)
  file(GLOB rime_preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
  install(FILES ${rime_preset_data_files} DESTINATION ${RIME_DATA_DIR})
endif()

if(BUILD_SHARED_LIBS)
  add_definitions(-DRIME_BUILD_SHARED_LIBS)
  set(rime_library rime)
  if(BUILD_SEPARATE_LIBS)
    set(rime_dict_library rime-dict)
    set(rime_gears_library rime-gears)
    set(rime_levers_library rime-levers)
  endif()
else()
  set(rime_library rime-static)
endif()

add_subdirectory(plugins)
message(STATUS "rime_plugins_libs: ${rime_plugins_deps}")
message(STATUS "rime_plugins_modules: ${rime_plugins_modules}")
set(list "")
foreach(mod ${rime_plugins_modules})
  set(list "${list},Q(${mod})")
endforeach()
add_definitions(-DRIME_EXTRA_MODULES=${list})
if(BUILD_SHARED_LIBS AND BUILD_SEPARATE_LIBS AND rime_plugins_objs)
  set(rime_plugins_library rime-plugins)
endif()

add_subdirectory(src)

if(BUILD_SHARED_LIBS)
  add_subdirectory(tools)

  if(BUILD_TEST)
    add_subdirectory(test)
  endif()

  if (BUILD_SAMPLE)
    add_subdirectory(sample)
  endif()
endif()

=== src/CMakeLists.txt ===
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

aux_source_directory(. rime_api_src)
aux_source_directory(rime rime_base_src)
aux_source_directory(rime/algo rime_algo_src)
aux_source_directory(rime/config rime_config_src)
aux_source_directory(rime/dict rime_dict_src)
aux_source_directory(rime/gear rime_gears_src)
aux_source_directory(rime/lever rime_levers_src)
if(rime_plugins_library)
  aux_source_directory(../plugins rime_plugins_src)
endif()

set(rime_core_module_src
  ${rime_api_src}
  ${rime_base_src}
  ${rime_config_src})
set(rime_dict_module_src
  ${rime_algo_src}
  ${rime_dict_src})

if(BUILD_SHARED_LIBS AND BUILD_SEPARATE_LIBS)
  set(rime_src ${rime_core_module_src})
else()
  set(rime_src
      ${rime_core_module_src}
      ${rime_dict_module_src}
      ${rime_gears_src}
      ${rime_levers_src}
      ${rime_plugins_src}
      ${rime_plugins_objs})
endif()

set(rime_optional_deps "")
if(Gflags_FOUND)
  set(rime_optional_deps ${rime_optional_deps} ${Gflags_LIBRARY})
endif()
if(ENABLE_EXTERNAL_PLUGINS)
  set(rime_optional_deps ${rime_optional_deps} dl)
endif()

set(rime_core_deps
    ${Boost_LIBRARIES}
    ${Glog_LIBRARY}
    ${YamlCpp_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    ${rime_optional_deps})
set(rime_dict_deps
    ${LevelDb_LIBRARY}
    ${Marisa_LIBRARY})
set(rime_gears_deps
    ${ICONV_LIBRARIES}
    ${ICU_LIBRARIES}
    ${Opencc_LIBRARY})
set(rime_levers_deps "")

if(MINGW)
  # fix: bcrypt for boost uuid issue
  # https://github.com/boostorg/uuid/issues/68
  set(rime_core_deps ${rime_core_deps} wsock32 ws2_32 bcrypt)
endif()

if(BUILD_SEPARATE_LIBS)
  set(rime_deps ${rime_core_deps})
else()
  set(rime_deps
    ${rime_core_deps}
    ${rime_dict_deps}
    ${rime_gears_deps}
    ${rime_levers_deps}
    ${rime_plugins_deps})
endif()

if(BUILD_SHARED_LIBS)
  add_library(rime ${rime_src})
  target_link_libraries(rime ${rime_deps})
  set_target_properties(rime PROPERTIES
    DEFINE_SYMBOL "RIME_EXPORTS"
    VERSION ${rime_version}
    SOVERSION ${rime_soversion})
  if(XCODE_VERSION)
    set_target_properties(rime PROPERTIES INSTALL_NAME_DIR "@rpath")
  endif()
  install(TARGETS rime DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

  if(BUILD_SEPARATE_LIBS)
    add_library(rime-dict ${rime_dict_module_src})
    target_link_libraries(rime-dict
      ${rime_dict_deps}
      ${rime_library})
    set_target_properties(rime-dict PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-dict PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-dict DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

    add_library(rime-gears ${rime_gears_src})
    target_link_libraries(rime-gears
      ${rime_gears_deps}
      ${rime_library}
      ${rime_dict_library})
    set_target_properties(rime-gears PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-gears PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-gears DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

    add_library(rime-levers ${rime_levers_src})
    target_link_libraries(rime-levers
      ${rime_levers_deps}
      ${rime_library}
      ${rime_dict_library})
    set_target_properties(rime-levers PROPERTIES
      VERSION ${rime_version}
      SOVERSION ${rime_soversion})
    if(XCODE_VERSION)
      set_target_properties(rime-levers PROPERTIES INSTALL_NAME_DIR "@rpath")
    endif()
    install(TARGETS rime-levers DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

    if(rime_plugins_library)
      add_library(rime-plugins
        ${rime_plugins_src}
        ${rime_plugins_objs})
      target_link_libraries(rime-plugins
        ${rime_plugins_deps}
        ${rime_library}
        ${rime_dict_library}
        ${rime_gears_library})
      set_target_properties(rime-plugins PROPERTIES
        VERSION ${rime_version}
        SOVERSION ${rime_soversion})
      if(XCODE_VERSION)
        set_target_properties(rime-plugins PROPERTIES INSTALL_NAME_DIR "@rpath")
      endif()
      install(TARGETS rime-plugins DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
    endif()
  endif()
else()
  add_library(rime-static STATIC ${rime_src})
  target_link_libraries(rime-static ${rime_deps})
  set_target_properties(rime-static PROPERTIES OUTPUT_NAME "rime" PREFIX "lib")
  install(TARGETS rime-static DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

=== debian/changelog ===
librime (1.10.0+dfsg1-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:34:43 +0000

librime (1.10.0+dfsg1-2build1) noble; urgency=medium

  * No-change rebuild against libgoogle-glog0v6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 02:23:03 +0000

librime (1.10.0+dfsg1-2) unstable; urgency=medium

  [ Benjamin Drung ]
  * Rename libraries for 64-bit time_t transition.  Closes: #1062609

 -- Boyuan Yang <byang@debian.org>  Wed, 28 Feb 2024 18:52:08 -0500

librime (1.10.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh plugin versions:
    + charcode: 20240209
    + lua: 20240206
    + octagram: 20240205
  * debian/librime1.shlibs: Bump minimum version to 1.10.0.
  * debian/control: Add build-dependency on libutfcpp-dev.
  * debian/copyright: Exclude libutfcpp headers, use system version.
  * debian/control: Drop unused boost components libboost-filesystem-dev,
    libboost-system-dev, libboost-thread-dev from build-dependency list.
  * debian/rules:
    + Enable ENABLE_TIMESTAMP flag for reproducible-builds.
    + Remove unused BOOST_USE_CXX11 flag.

 -- Boyuan Yang <byang@debian.org>  Sat, 10 Feb 2024 17:22:10 -0500

=== debian/control ===
Source: librime
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Qijiang Fan <fqj1994@gmail.com>,
 Aron Xu <aron@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>,
 Boyuan Yang <byang@debian.org>,
Build-Depends: dpkg-dev (>= 1.22.5),
 capnproto,
 cmake (>= 3.10),
 darts,
 debhelper-compat (= 13),
 googletest <!nocheck>,
 libboost-dev,
 libboost-locale-dev,
 libboost-regex-dev,
 libcapnp-dev,
 libgoogle-glog-dev,
 libleveldb-dev,
 liblua5.4-dev,
 libmarisa-dev,
 libopencc-dev (>= 1.1~),
 libutfcpp-dev (>= 3.2.4),
 libxcb-keysyms1-dev,
 libyaml-cpp-dev (>= 0.6.3-7~),
 pkg-config,
 x11proto-core-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/rime/librime
Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/librime

Package: librime-bin
Architecture: any
Depends:
 librime1t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 librime-data (>= 0.38),
Description: Rime Input Method Engine - utilities
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the executable utilities of RIME.
Section: utils

Package: librime-dev
Architecture: any
Section: libdevel
Depends:
 librime1t64 (<< ${source:Upstream-Version}.0~),
 librime1t64 (>= ${source:Version}),
 ${misc:Depends},
Provides:
 librime1-dev,
Conflicts:
 librime1-dev,
Replaces:
 librime1-dev,
Description: Rime Input Method Engine, the core library - development files
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the development files of RIME.

Package: librime-plugin-charcode
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Homepage: https://github.com/rime/librime-charcode
Description: Rime Input Method Engine - charcode plugin
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides charcode plugin for RIME. It can be used for codepoint
 translation and charset filtering.

Package: librime-plugin-lua
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Homepage: https://github.com/hchunhui/librime-lua
Description: Rime Input Method Engine - Lua extension plugin
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides lua extension plugin for RIME with the following
 features:
 .
   * Supports extending RIME processors, segmentors, translators and filters
   * Provides high-level programming model for translators and filters
   * Loaded dynamically as a librime plugin

Package: librime-plugin-octagram
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Homepage: https://github.com/lotem/librime-octagram
Description: Rime Input Method Engine - octagram plugin
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides octagram plugin for RIME. It provides extra functionality
 in grammar checking.

Package: librime1t64
Provides: ${t64:Provides}
Replaces: librime1
Breaks: librime1 (<< ${source:Version})
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Recommends:
 librime-bin,
 librime-data (>= 0.38),
 librime-plugin-charcode,
 librime-plugin-lua,
 librime-plugin-octagram,
Description: Rime Input Method Engine - core library
 RIME is the acronym of Rime Input Method Engine.
 .
 RIME is a lightweight, extensible input method engine supporting various input
 schematas including glyph-based input methods, romanization-based input methods
 as well as those for Chinese dialects. It has the ability to compose phrases
 and sentences intelligently and provide very accurate traditional Chinese
 output. RIME's cross-platform core library is written in C++, and can work
 consistently on different platforms with OS-specific wrappers.
 .
 This package provides the core library of RIME.

=== debian/rules ===
#!/usr/bin/make -f

# See dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  =

include /usr/share/dpkg/default.mk

# For individual package versions
REV_CHARCODE = 20230904
REV_LUA = 20230917
REV_OCTAGRAM = 20230125

_DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LIBRIME_BUILD_TEST_FLAG := ON
else
	LIBRIME_BUILD_TEST_FLAG := OFF
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	cp -r ./librime-lua ./plugins/lua
	cp -r ./librime-octagram ./plugins/octagram
	cp -r ./librime-charcode ./plugins/charcode
	dh_auto_configure -Scmake -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DINSTALL_PRIVATE_HEADERS=ON \
	    -DENABLE_EXTERNAL_PLUGINS=ON \
	    -DBUILD_TEST=$(LIBRIME_BUILD_TEST_FLAG) \
	    -DBUILD_MERGED_PLUGINS=Off \
	    -DENABLE_EXTERNAL_PLUGINS=On \
	    -DENABLE_TIMESTAMP=ON \
	    $(NULL)

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md

execute_after_dh_fixperms:
	# https://github.com/rime/librime/issues/520
	chmod 755 $(CURDIR)/debian/*/usr/lib/*/rime-plugins/*.so

# Individual version number for librime-plugin-*
override_dh_gencontrol:
	dh_gencontrol -plibrime-plugin-charcode -- \
	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_CHARCODE)-$(_DEB_VERSION_REVISION)
	dh_gencontrol -plibrime-plugin-lua -- \
	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_LUA)-$(_DEB_VERSION_REVISION)
	dh_gencontrol -plibrime-plugin-octagram -- \
	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_OCTAGRAM)-$(_DEB_VERSION_REVISION)
	dh_gencontrol --remaining-packages

## librime 1.11.2+dfsg1

=== debian/changelog ===
librime (1.11.2+dfsg1-1deepin1) unstable; urgency=medium

  * Revert t64

 -- xiangzelong <xiangzelong@deepin.org>  Tue, 09 Jul 2024 10:46:16 +0800

librime (1.11.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh plugin versions:
    + lua: 20240519
  * debian/librime1t64.shlibs: Bump minimum version to 1.11.2.

 -- Boyuan Yang <byang@debian.org>  Sun, 07 Jul 2024 20:05:55 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: librime
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Qijiang Fan <fqj1994@gmail.com>,
  Aron Xu <aron@debian.org>,
@@ -28,11 +27,11 @@
  libutfcpp-dev (>= 3.2.4),
  libxcb-keysyms1-dev,
  libyaml-cpp-dev (>= 0.6.3-7~),
- pkg-config,
+ pkgconf,
  x11proto-core-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/rime/librime
 Vcs-Git: https://salsa.debian.org/input-method-team/librime.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/librime
@@ -40,7 +39,7 @@
 Package: librime-bin
 Architecture: any
 Depends:
- librime1t64 (= ${binary:Version}),
+ librime1 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
@@ -62,8 +61,8 @@
 Architecture: any
 Section: libdevel
 Depends:
- librime1t64 (<< ${source:Upstream-Version}.0~),
- librime1t64 (>= ${source:Version}),
+ librime1 (<< ${source:Upstream-Version}.0~),
+ librime1 (>= ${source:Version}),
  ${misc:Depends},
 Provides:
  librime1-dev,
@@ -147,10 +146,7 @@
  This package provides octagram plugin for RIME. It provides extra functionality
  in grammar checking.
 
-Package: librime1t64
-Provides: ${t64:Provides}
-Replaces: librime1
-Breaks: librime1 (<< ${source:Version})
+Package: librime1
 Architecture: any
 Depends:
  ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,9 @@
 include /usr/share/dpkg/default.mk
 
 # For individual package versions
-REV_CHARCODE = 20230904
-REV_LUA = 20230917
-REV_OCTAGRAM = 20230125
+REV_CHARCODE = 20240209
+REV_LUA = 20240519
+REV_OCTAGRAM = 20240205
 
 _DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')

## librime 1.12.0%2Bdfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 project(rime)
 set(CMAKE_CXX_STANDARD 17)
 
-set(rime_version 1.10.0)
+set(rime_version 1.12.0)
 set(rime_soversion 1)
 
 add_definitions(-DRIME_VERSION="${rime_version}")
@@ -27,8 +27,8 @@
 option(ENABLE_THREADING "Enable threading for deployer" ON)
 option(ENABLE_TIMESTAMP "Embed timestamp to schema artifacts" ON)
 
-set(RIME_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/rime-data" CACHE STRING "Target directory for Rime data")
-set(RIME_PLUGINS_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/rime-plugins" CACHE STRING "Target directory for externally built Rime plugins")
+set(RIME_DATA_DIR "rime-data" CACHE STRING "Target directory for Rime data")
+set(RIME_PLUGINS_DIR "rime-plugins" CACHE STRING "Target directory for externally built Rime plugins")
 
 if(WIN32)
   set(ext ".exe")
@@ -80,9 +80,19 @@
   find_package(Glog REQUIRED)
   if(Glog_FOUND)
     include_directories(${Glog_INCLUDE_PATH})
-  endif()
-  if(Glog_STATIC)
-    add_definitions(-DGOOGLE_GLOG_DLL_DECL=)
+    if(WIN32)
+      add_compile_definitions("GLOG_DEPRECATED=__declspec(deprecated)")
+      add_compile_definitions(GLOG_NO_ABBREVIATED_SEVERITIES)
+    else()
+      add_compile_definitions("GLOG_DEPRECATED=__attribute__((deprecated))")
+    endif()
+    if(Glog_STATIC)
+      add_compile_definitions(GLOG_EXPORT=)
+      add_compile_definitions(GLOG_NO_EXPORT=)
+    else()
+      add_compile_definitions("GLOG_EXPORT=__attribute__((visibility(\"default\")))")
+      add_compile_definitions("GLOG_NO_EXPORT=__attribute__((visibility(\"default\")))")
+    endif()
   endif()
 
   set(RIME_ENABLE_LOGGING 1)
@@ -158,6 +168,10 @@
   set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
   set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
   add_definitions("/wd4244 /wd4996")
+
+  # large address aware
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /LARGEADDRESSAWARE")
+  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /LARGEADDRESSAWARE")
 endif()
 
 if(UNIX)
@@ -190,13 +204,13 @@
 add_custom_target(remove
   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|DragonFly|GNU|Darwin" OR MINGW)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Linux|FreeBSD|OpenBSD|DragonFly|GNU|Darwin" OR MINGW)
   set(prefix "${CMAKE_INSTALL_PREFIX}")
   set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
   set(bindir "${CMAKE_INSTALL_FULL_BINDIR}")
   set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
-  set(pkgdatadir "${RIME_DATA_DIR}")
-  set(pluginsdir "${RIME_PLUGINS_DIR}")
+  set(pkgdatadir "${CMAKE_INSTALL_FULL_DATADIR}/${RIME_DATA_DIR}")
+  set(pluginsdir "${CMAKE_INSTALL_FULL_LIBDIR}/${RIME_PLUGINS_DIR}")
   set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
   configure_file(
       ${PROJECT_SOURCE_DIR}/rime.pc.in
@@ -210,6 +224,7 @@
   DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/cmake/rime)
 
 file(GLOB rime_public_header_files ${PROJECT_SOURCE_DIR}/src/*.h)
+list(FILTER rime_public_header_files EXCLUDE REGEX .*_impl\.h$)
 install(FILES ${rime_public_header_files}
   DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR})
 if(INSTALL_PRIVATE_HEADERS)
@@ -228,7 +243,7 @@
 
 if(BUILD_DATA)
   file(GLOB rime_preset_data_files ${PROJECT_SOURCE_DIR}/data/preset/*.yaml)
-  install(FILES ${rime_preset_data_files} DESTINATION ${RIME_DATA_DIR})
+  install(FILES ${rime_preset_data_files} DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/${RIME_DATA_DIR})
 endif()
 
 if(BUILD_SHARED_LIBS)

## librime 1.12.0+dfsg1

=== debian/changelog ===
librime (1.12.0+dfsg1-1deepin1) unstable; urgency=medium

  * Revert t64.

 -- xiangzelong <xiangzelong@deepin.org>  Mon, 09 Dec 2024 10:15:27 +0800

librime (1.12.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Nov 2024 22:30:42 -0500

librime (1.12.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh plugin version:
    + lua: 20241102
  * debian/librime1t64.shlibs: Bump versions.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Nov 2024 18:28:17 -0500

librime (1.11.2+dfsg1-3) unstable; urgency=medium

  * Rebuild against libopencc 1.1.9.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Aug 2024 15:57:43 -0400

librime (1.11.2+dfsg1-2) unstable; urgency=medium

  * Rebuild against libopencc 1.1.8.
  * debian/patches/0001-Use-googletest-lib-built-from-source.patch:
    Mark the patch as Forwarded: not-needed.

 -- Boyuan Yang <byang@debian.org>  Mon, 29 Jul 2024 15:45:22 -0400

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
  libleveldb-dev,
  liblua5.4-dev,
  libmarisa-dev,
- libopencc-dev (>= 1.1~),
+ libopencc-dev (>= 1.1.9~),
  libutfcpp-dev (>= 3.2.4),
  libxcb-keysyms1-dev,
  libyaml-cpp-dev (>= 0.6.3-7~),

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # For individual package versions
 REV_CHARCODE = 20240209
-REV_LUA = 20240519
+REV_LUA = 20241102
 REV_OCTAGRAM = 20240205
 
 _DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')

## librime 1.13.0+dfsg1

=== debian/changelog ===
librime (1.13.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 28 Jan 2025 09:40:56 -0500

librime (1.13.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh plugin version:
    + lua: 20241221.
    + charcode: 20240319.
    + octagram: 20241118.
  * debian/librime1t64.shlibs: Bump versions.

 -- Boyuan Yang <byang@debian.org>  Sat, 25 Jan 2025 17:13:27 -0500

## librime 1.13.1+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 project(rime)
 set(CMAKE_CXX_STANDARD 17)
 
-set(rime_version 1.12.0)
+set(rime_version 1.13.1)
 set(rime_soversion 1)
 
 add_definitions(-DRIME_VERSION="${rime_version}")

=== librime-predict/CMakeLists.txt ===
project(rime-predict)
cmake_minimum_required(VERSION 3.10)

option(BUILD_TOOLS "Build tools" ON)

aux_source_directory(src predict_src)

add_library(rime-predict-objs OBJECT ${predict_src})
if(BUILD_SHARED_LIBS)
  set_target_properties(rime-predict-objs
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
endif()

set(plugin_name rime-predict PARENT_SCOPE)
set(plugin_objs $<TARGET_OBJECTS:rime-predict-objs> PARENT_SCOPE)
set(plugin_deps ${rime_library} PARENT_SCOPE)
set(plugin_modules "predict" PARENT_SCOPE)

if(BUILD_TOOLS)
  add_subdirectory(tools)
endif()

=== librime-predict/tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

aux_source_directory(. build_predict_src)
include_directories(../src)

add_executable(build_predict
  ${build_predict_src}
  $<TARGET_OBJECTS:rime-predict-objs>)
target_link_libraries(build_predict
  ${rime_library}
  ${rime_dict_library})

=== debian/changelog ===
librime (1.13.1+dfsg1-1deepin2) unstable; urgency=medium

  * Revert t64.
  * Add new plugin predict.

 -- xiangzelong <xiangzelong@deepin.org>  Mon, 31 Mar 2025 11:29:25 +0800

librime (1.13.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/librime1t64.shlibs: Bump versions.

 -- Boyuan Yang <byang@debian.org>  Mon, 03 Mar 2025 11:14:32 -0500

=== debian/control ===
--- 
+++ 
@@ -61,8 +61,7 @@
 Architecture: any
 Section: libdevel
 Depends:
- librime1 (<< ${source:Upstream-Version}.0~),
- librime1 (>= ${source:Version}),
+ librime1
  ${misc:Depends},
 Provides:
  librime1-dev,
@@ -146,6 +145,25 @@
  This package provides octagram plugin for RIME. It provides extra functionality
  in grammar checking.
 
+Package: librime-plugin-predict
+Architecture: any
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Multi-Arch: same
+Homepage: https://github.com/rime/librime-predict
+Description: Rime Input Method Engine - predict plugin
+ RIME is the acronym of Rime Input Method Engine.
+ .
+ RIME is a lightweight, extensible input method engine supporting various input
+ schematas including glyph-based input methods, romanization-based input methods
+ as well as those for Chinese dialects. It has the ability to compose phrases
+ and sentences intelligently and provide very accurate traditional Chinese
+ output. RIME's cross-platform core library is written in C++, and can work
+ consistently on different platforms with OS-specific wrappers.
+ This package provides predict plugin for RIME. It provides extra functionality
+ in predicting the next input.
+
 Package: librime1
 Architecture: any
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,10 @@
 include /usr/share/dpkg/default.mk
 
 # For individual package versions
-REV_CHARCODE = 20240209
-REV_LUA = 20241102
-REV_OCTAGRAM = 20240205
+REV_CHARCODE = 20240319
+REV_LUA = 20241221
+REV_OCTAGRAM = 20241118
+REV_PREDICT = 20241108
 
 _DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')
 
@@ -26,6 +27,7 @@
 	cp -r ./librime-lua ./plugins/lua
 	cp -r ./librime-octagram ./plugins/octagram
 	cp -r ./librime-charcode ./plugins/charcode
+	cp -r ./librime-predict ./plugins/predict
 	dh_auto_configure -Scmake -- \
 	    -DCMAKE_BUILD_TYPE=Release \
 	    -DINSTALL_PRIVATE_HEADERS=ON \
@@ -51,4 +53,6 @@
 	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_LUA)-$(_DEB_VERSION_REVISION)
 	dh_gencontrol -plibrime-plugin-octagram -- \
 	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_OCTAGRAM)-$(_DEB_VERSION_REVISION)
+	dh_gencontrol -plibrime-plugin-predict -- \
+	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_PREDICT)-$(_DEB_VERSION_REVISION)
 	dh_gencontrol --remaining-packages

## librime 1.14.0%2Bdfsg1

=== tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

aux_source_directory(. build_grammar_src)
include_directories(../src)

# msvc doesn't export all symbols
if(NOT (WIN32 AND BUILD_SHARED_LIBS))
  add_executable(build_grammar
    ${build_grammar_src}
    $<TARGET_OBJECTS:rime-octagram-objs>)
  target_link_libraries(build_grammar
    ${rime_library}
    ${rime_dict_library})
endif()
